<template>
  <div
    :class="{
      'InputField--withLabel': !!label,
      'InputField--HasChanged': hasChanged,
    }"
    class="InputField"
  >
    <label v-if="label" :for="uuid + '_select'" class="InputField__Label">
      {{ label }}
    </label>
    <!--suppress HtmlFormInputWithoutLabel -->
    <input
      :id="uuid + '_select'"
      v-model="value"
      :placeholder="placeholder || label"
      :type="type"
      class="InputField__Control"
    />
  </div>
</template>

<script lang="ts">
import { defineComponent } from 'vue'
import { isControl, ControlEmits } from '@/components/controls/mixins/IsControl'

export default defineComponent({
  name: 'InputField',
  emits: [...ControlEmits],
  props: {
    label: String,
    type: String,
    modelValue: String,
    restoreValue: null,
    noTranslate: Boolean,
    placeholder: String,
    debounceDelay: Number,
  },

  setup(props, context) {
    return {
      ...isControl<string>({ props, context }),
    }
  },
})
</script>

<style lang="scss" scoped>
@use '../../style/variables' as v;
@use './mixins/control' as c;

.InputField {
  @include c.control;

  padding: 0;
  border-color: transparent;
  border-radius: v.$borderRadius;

  &--withLabel {
    border-color: var(--text-color);
  }

  &__Control {
    width: 100%;
    padding: v.$spacing-4 v.$spacing-2;
    border: none;
    background-color: transparent;
    color: var(--text-color);
  }
}
</style>
